'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Programmname: Anpassen_HomeDirectory.cmd
'
' Beschreibung: Ersetzt das Homedirectory
' 		        von Benutzerkonten einer einzugebenden OU
'		
'
' Version:      v.3.1
'
' Datum:        2013-04-22
'
' Autor:        Erich Vonach
'               IT-Regionalbetreuer
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''



Abfrage = MsgBox ("Durch Ausfhren dieses Scripts wird das Homedirectory " _
	& vbCrLf &  "von allen Benutzern einer auswhlbaren OU durch ein" _
	& vbCrLf & "- anzugebendes - neues Homedirectory ersetzt!" & vbCrLf _
	& vbCrLf & "Fhren Sie dieses Script nur dann weiter aus, " _
	& vbCrLf & "wenn Sie sicher sind, welche Auswirkungen dies hat!", _
	vbOKCancel + vbInformation, "Information")
	
	If Abfrage = vbOK Then
		'Verbindung zur Domne --------------------------------------------
		set objRoot = GetObject("LDAP://rootDSE")
		set fs = CreateObject("Scripting.FilesystemObject")
		strDomain = objRoot.Get("DefaultNamingContext")

		'Logdatei anlegen -------------------------------------------------
		strScriptName = Wscript.ScriptFullName 
		strScriptPfad = fs.getparentfoldername(strScriptName)
		strLogPfad = left(strScriptPfad, InstrRev(strScriptPfad, ""))

		set objFSO = CreateObject("Scripting.FileSystemObject")
		with objFSO
			dateiPfad = .BuildPath(strLogPfad, "Log")
			if not .FolderExists(dateiPfad) then .CreateFolder(dateiPfad)
				dateiName = "homeDirectory_" & CStr(Now) & ".log"
				dateiName = replace(dateiName, ":", "-")
				pfadName = .BuildPath(dateiPfad, dateiName)
			set objDatei = .CreateTextFile(pfadName)
		end with

		SchreibLog Now
		SchreibLog "Skript gestartet" & vbCrLf

		'Abfragen ---------------------------------------------------------
		'OU
		strOU = InputBox("Welcher Container soll bearbeitet werden?" _
		& vbCrLf & "(LDAP-Angabe ohne Domne)"& vbCrLf _
		& vbCrLf & "Beispiel 1:  CN=Users"_
		& vbCrLf & "Beispiel 2:  OU=Schueler,OU=Benutzer,OU=Schule","Angaben zur Domne", "OU=Schueler,OU=Benutzer,OU=Schule")
		
		If strOU <> "" Then
			'HomeDirectory
			strHome = InputBox("Eingabe des Basisordners (obligatorisch)" & vbCrLf _
			& vbCrLf & "- Angabe der Basisfreigabe!"_
			& vbCrLf & "- ohne Angabe der Domne!" & vbCrLf _
			& vbCrLf & "Beispiel 1:  Klassen"_
			& vbCrLf & "Beispiel 2:  grpLehrer$"_
			& vbCrLf & "Beispiel 3:  Home$\grpLehrer","HomeDirectory","Klassen")

			If strHome <> "" Then
				SchreibLog "----------------------------------------------------"_
				& vbCrLf & "Aufgabe: Neues Homedirectory der User des Containers"_
				& vbCrLf & vbCrLf &"'" & strOU & "'" & vbCrLf _
				& vbCrLf & "erstellen."_
				& vbCrLf & "----------------------------------------------------"
				' Verbindungsstring zur Domne
				strObjOU = "LDAP://" & strOU & "," & strDomain
				'MsgBox "OU: " & strObjOU & vbCrLf & vbCrLf & "neues Homedirectory: " & strHome, vbOKCancel + vbInformation,  "Angaben zu den neuen Daten"

				' OU ansprechen
				set objOU = GetObject(strObjOU)
				objOU.Filter = Array("user")

				' Log-Zhler initialisieren
				intErfolg = 0
				intFehler = 0
				
				'Abfrage: Mit oder ohne Benutzerdirectory
 	  			strUser = MsgBox("Soll das neue Homedirectory personalisiert werden?"& vbCrLf _
					& vbCrLf &"Ja:    ...\" & strHome & "\%Username%" _
					& vbCrLf &"Nein: ...\" & strHome, _
					vbYesNo + vbQuestion, _
					"Angabe zur Personalisierung")
					
				If strUser = vbYes Then
					
					'Abfrage: zustzliches Datendirectory
 	  				strHomeData = InputBox("Soll ein zustzliches Unterverzeichnis angelegt werden?"& vbCrLf _
						& vbCrLf &"OK:             ...\" & strHome & "\%Username%" & "\Daten" _
						& vbCrLf &"Abbrechen: ...\" & strHome & "\%Username%", _
						"zustzliches Datenverzeichnis", "Daten")
				Else
					strHomeData = ""
				End If
									
				' alle Objekte in der OU bearbeiten
				on error resume next 'Fehler abfangen
				
				for each varUser in objOU
 			   	' Variablen initialisieren
					strSAMname = ""
					strHomeDirectoryOld = ""
					strHomeDirectoryNeu = ""

					set objUser = GetObject("LDAP://" & varUser.Name & "," & strOU & "," & strDomain)
					'objUser.GetInfo
					strHomeDirectoryOld = objUser.Get("HomeDirectory")
 	  				strSAMname = objUser.Get("sAMAccountName")
 	  				
					If strUser = vbYes Then
						If strHomeData <> "" Then
							strHomeDirectoryNeu = "\\schule.aps\dfs\" & strHome & "\" & strSAMname & "\" & strHomeData
							objUser.HomeDirectory = strHomeDirectoryNeu
  		  					objUser.SetInfo
  		  				Else 
  		  					strHomeDirectoryNeu = "\\schule.aps\dfs\" & strHome & "\" & strSAMname
							objUser.HomeDirectory = strHomeDirectoryNeu
  		  					objUser.SetInfo
  		  				End If
  		  			Else
						strHomeDirectoryNeu = "\\schule.aps\dfs\" & strHome
						objUser.HomeDirectory = strHomeDirectoryNeu
  		  				objUser.SetInfo	
  		  			End If

                	schreibLog "Benutzer: " & strSAMname

                	' Logging: Fehler kontrollieren
                	
                	if err.number <> 0 then
                     	SchreibLog "Fehler: " & err.number & ", " & err.description
                     	intFehler = intFehler + 1
                     	err.Clear
                	elseif strHomeDirectoryOld <> "" then
                     	SchreibLog "Erfolg"
                     	SchreibLog "Alter Wert: " & strHomeDirectoryOld
                     	SchreibLog "Neuer Wert: " & strHomeDirectoryNeu
                     	intErfolg = intErfolg + 1
                	end if
                		
                	SchreibLog vbCrLf

				next

				on error goto 0 'Fehlerbehandlung wieder an

				' Erfolgsmeldung ausgeben
				saylog intErfolg & " Benutzer bearbeitet, " & intFehler & " Fehler aufgetreten." & vbCrLf
				schreibLog Now
				schreibLog "Skript beendet"
				objDatei.Close


				sub SchreibLog(strText)
  	  			' Funktion: schreibt angegebenen Text in die Logdatei
    			' Eingabeparameter:
    			' Kommentar:
   		 			objDatei.WriteLine strText
				end sub

				sub saylog(strText)
    				msgBox strText
    				SchreibLog strText
				end Sub

			Else
				MsgBox ("Abbruch durch Benutzer"),vbCritical
			End If
			
		Else
			MsgBox ("Abbruch durch Benutzer"),vbCritical
		End If
	Else
		MsgBox ("Abbruch durch Benutzer"),vbCritical
	End If