'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Programmname: Anpassen_ProfilePath.cmd
'
' Beschreibung: Passt den Profilpfad
' 		        von Benutzerkonten einer einzugebenden OU an
'		
'
' Version:      v.3.1
'
' Datum:        2013-04-22
'
' Autor:        Erich Vonach
'               IT-Regionalbetreuer
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''



Abfrage = MsgBox ("Durch Ausfhren dieses Scripts wird der Profilpfad " _
	& vbCrLf &  "von allen Benutzern einer auswhlbaren OU durch einen " _
	& vbCrLf & "- anzugebenden - neuen Profilpfad ersetzt!"& vbCrLf _
	& vbCrLf & "Fhren Sie dieses Script nur dann weiter aus, " _
	& vbCrLf & "wenn Sie sicher sind, welche Auswirkungen dies hat!", _
	vbOKCancel + vbInformation, "Information")
	
	If Abfrage = vbOK Then
		'Verbindung zur Domne --------------------------------------------
		set objRoot = GetObject("LDAP://rootDSE")
		set fs = CreateObject("Scripting.FilesystemObject")
		strDomain = objRoot.Get("DefaultNamingContext")

		'Logdatei anlegen -------------------------------------------------
		strScriptName = Wscript.ScriptFullName 
		strScriptPfad = fs.getparentfoldername(strScriptName)
		strLogPfad = left(strScriptPfad, InstrRev(strScriptPfad, ""))

		set objFSO = CreateObject("Scripting.FileSystemObject")
		with objFSO
			dateiPfad = .BuildPath(strLogPfad, "Log")
			if not .FolderExists(dateiPfad) then .CreateFolder(dateiPfad)
				dateiName = "profilePath_" & CStr(Now) & ".log"
				dateiName = replace(dateiName, ":", "-")
				pfadName = .BuildPath(dateiPfad, dateiName)
			set objDatei = .CreateTextFile(pfadName)
		end with

		SchreibLog Now
		SchreibLog "Skript gestartet" & vbCrLf

		'Abfragen ---------------------------------------------------------
		'OU
		strOU = InputBox("Welcher Container soll bearbeitet werden?" _
		& vbCrLf & "(LDAP-Angabe ohne Domne)"& vbCrLf _
		& vbCrLf &"Beispiel 1:  CN=Users"_
		& vbCrLf & "Beispiel 2:  OU=Schueler,OU=Benutzer,OU=Schule","Angaben zur Domne", "OU=Schueler,OU=Benutzer,OU=Schule")
		
		If strOU <> "" Then
			'Profilpfad
			strProfile = InputBox("Eingabe des Basisordners (obligatorisch)" & vbCrLf _
			& vbCrLf & "- incl. Angabe der Basisfreigabe!"_
			& vbCrLf & "- ohne Angabe der Domne!" & vbCrLf _
			& vbCrLf & "Beispiel 1:  grpSchueler$"_
			& vbCrLf & "Beispiel 2:  Home$\grpSchueler","Profilpfad","grpSchueler$")

			If strProfile <> "" Then
				SchreibLog "-------------------------------------------------"_
				& vbCrLf & "Aufgabe: Neuen Profilpfad der User des Containers"_
				& vbCrLf & vbCrLf & strOU & vbCrLf _
				& vbCrLf & "erstellen."_
				& vbCrLf & "-------------------------------------------------"
				' Verbindungsstring zur Domne
				strObjOU = "LDAP://" & strOU & "," & strDomain

				' OU ansprechen
				set objOU = GetObject(strObjOU)
				objOU.Filter = Array("user")

				' Log-Zhler initialisieren
				intErfolg = 0
				intFehler = 0
				
				'Abfrage: Mit oder ohne Benutzerdirectory
 	  			strUser = MsgBox("Soll der neue Profilpfad personalisiert sein?"& vbCrLf _
					& vbCrLf &"Ja:    ...\" & strProfile & "\%Username%" _
					& vbCrLf &"Nein: ...\" & strProfile, _
					vbYesNo + vbQuestion, _
					"Angabe zur Personalisierung")
					
				If strUser = vbYes Then
					
					'Abfrage: zustzliches Datendirectory
 	  				strProfileData = InputBox("Soll ein zustzliches Unterverzeichnis angelegt werden?"& vbCrLf _
						& vbCrLf &"OK:             ...\" & strProfile & "\%Username%" & "\Profil" _
						& vbCrLf &"Abbrechen: ...\" & strProfile & "\%Username%", _
						"zustzliches Datenverzeichnis", "Profil")
				Else
					strprofileData = ""
				End If
									
				' alle Objekte in der OU bearbeiten
				on error resume next 'Fehler abfangen
				
				for each varUser in objOU
 			   	' Variablen initialisieren
					strSAMname = ""
					strProfileDirectoryOld = ""
					strProfileDirectoryNeu = ""

					set objUser = GetObject("LDAP://" & varUser.Name & "," & strOU & "," & strDomain)
					'objUser.GetInfo
					strProfileDirectoryOld = objUser.Get("profilePath")
 	  				strSAMname = objUser.Get("sAMAccountName")
 	  				
					If strUser = vbYes Then
						If strProfileData <> "" Then
							strProfileDirectoryNeu = "\\schule.aps\dfs\" & strProfile & "\" & strSAMname & "\" & strProfileData
							objUser.profilePath = strprofileDirectoryNeu
  		  					objUser.SetInfo
  		  				Else 
  		  					strprofileDirectoryNeu = "\\schule.aps\dfs\" & strprofile & "\" & strSAMname
							objUser.profilePath = strprofileDirectoryNeu
  		  					objUser.SetInfo
  		  				End If
  		  			Else
						strProfileDirectoryNeu = "\\schule.aps\dfs\" & strProfile
						objUser.profilePath = strProfileDirectoryNeu
  		  				objUser.SetInfo	
  		  			End If

                	schreibLog "Benutzer: " & strSAMname

                	' Logging: Fehler kontrollieren
                	
                	if err.number <> 0 then
                     	SchreibLog "Fehler: " & err.number & ", " & err.description
                     	intFehler = intFehler + 1
                     	err.Clear
                	elseif strprofileDirectoryOld <> "" then
                     	SchreibLog "Erfolg"
                     	SchreibLog "Alter Wert: " & strProfileDirectoryOld
                     	SchreibLog "Neuer Wert: " & strProfileDirectoryNeu
                     	intErfolg = intErfolg + 1
                	end if
                		
                	SchreibLog vbCrLf

				next

				on error goto 0 'Fehlerbehandlung wieder an

				' Erfolgsmeldung ausgeben
				saylog intErfolg & " Benutzer bearbeitet, " & intFehler & " Fehler aufgetreten." & vbCrLf
				schreibLog Now
				schreibLog "Skript beendet"
				objDatei.Close


				sub SchreibLog(strText)
  	  			' Funktion: schreibt angegebenen Text in die Logdatei
    			' Eingabeparameter:
    			' Kommentar:
   		 			objDatei.WriteLine strText
				end sub

				sub saylog(strText)
    				msgBox strText
    				SchreibLog strText
				end Sub

			Else
				MsgBox ("Abbruch durch Benutzer"),vbCritical
			End If
			
		Else
			MsgBox ("Abbruch durch Benutzer"),vbCritical
		End If
	Else
		MsgBox ("Abbruch durch Benutzer"),vbCritical
	End If