' ----------------------------------------------
' Searching, Downloading, and Installing Updates
' ----------------------------------------------
' https://social.technet.microsoft.com/Forums/en-US/210c4a1a-83da-4d78-9cfd-bce8e50ac9b6/automating-windows-updates?forum=winserverwsus
' Ursprung: https://docs.microsoft.com/en-us/windows/desktop/Wua_Sdk/searching--downloading--and-installing-updates
' START: c:\windows\system32\cscript C:\AutomateWinUpdates\WUA_SearchDownloadInstall.vbs >> C:\AutomateWinUpdates\updatelog.txt
' 09/31/2018
'  I left the reboot command out for now. Not sure if I'll use it.  
' ----------------------------------------------
' and AutoSelectOnWebsites=1  ---:  recommended only


'Option Explicit
dim objFSO
Const ForReading = 1, ForWriting = 2, ForAppending = 8 

Set objFSO = CreateObject("Scripting.FileSystemObject")
' Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
Set myLog = objFSO.OpenTextFile("C:\_rb-logs\Win10-rbUpdateLog.log", ForAppending, True)

Set updateSession = CreateObject("Microsoft.Update.Session")
updateSession.ClientApplicationID = "rb-Windows10-Updates-Autoinstall"

Set updateSearcher = updateSession.CreateUpdateSearcher()

   WScript.Echo now() & ": Searching for updates..." & vbCRLF
myLog.WriteLine now() & ": Searching for updates..." & vbCRLF

Set searchResult = _
updateSearcher.Search("IsInstalled=0 and Type='Software' and IsHidden=0 and AutoSelectOnWebsites=1")

WScript.Echo now() & ": List of applicable items on the machine:"

For I = 0 To searchResult.Updates.Count-1
    Set update = searchResult.Updates.Item(I)
       WScript.Echo I + 1 & "> " & update.Title
    myLog.WriteLine I + 1 & "> " & update.Title

Next

If searchResult.Updates.Count = 0 Then
    WScript.Echo    now() & ": There are no applicable updates."
    myLog.WriteLine now() & ": There are no applicable updates."
    WScript.Quit
End If

WScript.Echo    now() & ": Creating collection of updates to download:" & vbCRLF
myLog.WriteLine now() & ": Creating collection of updates to download:" & vbCRLF

Set updatesToDownload = CreateObject("Microsoft.Update.UpdateColl")

For I = 0 to searchResult.Updates.Count-1
    Set update = searchResult.Updates.Item(I)
    addThisUpdate = false
    If update.InstallationBehavior.CanRequestUserInput = true Then
        WScript.Echo I + 1 & "> skipping: " & update.Title & " because it requires user input"
        myLog.WriteLine I + 1 & "> skipping: " & update.Title & " because it requires user input"
    Else
        If update.EulaAccepted = false Then
            ' This portion of the script used to prompt for user input for accepting a EULA 
            ' Automatically Agree and keep moving forward
            update.AcceptEula()
            addThisUpdate = true
        Else
            addThisUpdate = true
        End If
    End If
    If addThisUpdate = true Then
        WScript.Echo    I + 1 & "> adding: " & update.Title 
        myLog.WriteLine I + 1 & "> adding: " & update.Title 

        updatesToDownload.Add(update)
    End If
Next

If updatesToDownload.Count = 0 Then
    WScript.Echo    now() & ": All applicable updates were skipped."
    myLog.WriteLine now() & ": All applicable updates were skipped."
    WScript.Quit
End If
    
WScript.Echo    now() & ": Downloading updates..." & vbCRLF
myLog.WriteLine now() & ": Downloading updates..." & vbCRLF

Set downloader = updateSession.CreateUpdateDownloader() 
downloader.Updates = updatesToDownload
downloader.Download()

Set updatesToInstall = CreateObject("Microsoft.Update.UpdateColl")

rebootMayBeRequired = false

WScript.Echo now() & ": Successfully downloaded updates:"  & vbCRLF
WScript.Echo now() & ": Successfully downloaded updates:"  & vbCRLF

For I = 0 To searchResult.Updates.Count-1
    set update = searchResult.Updates.Item(I)
    If update.IsDownloaded = true Then
        WScript.Echo    I + 1 & "> " & update.Title 
        myLog.WriteLine I + 1 & "> " & update.Title 
        updatesToInstall.Add(update) 
        If update.InstallationBehavior.RebootBehavior > 0 Then
            rebootMayBeRequired = true
        End If
    End If
Next

If updatesToInstall.Count = 0 Then
    WScript.Echo    now() & ": No updates were successfully downloaded."
    myLog.WriteLine now() & ": No updates were successfully downloaded."
    WScript.Quit
End If

If rebootMayBeRequired = true Then
    WScript.Echo    now() & ": These updates may require a reboot." & vbCRLF
    myLog.WriteLine now() & ": These updates may require a reboot." & vbCRLF
End If

' This portion of the script used to prompt for user input for installation
' If the script is running then we want the updates, just install them
WScript.Echo    now() & ": Installing updates..." & vbCRLF
myLog.WriteLine now() & ": Installing updates..." & vbCRLF
Set installer = updateSession.CreateUpdateInstaller()
installer.Updates = updatesToInstall
Set installationResult = installer.Install()

'Output results of install
WScript.Echo now() & ": Installation Result: " & installationResult.ResultCode 
WScript.Echo now() & ": Reboot Required: " & installationResult.RebootRequired & vbCRLF 
WScript.Echo now() & ": Listing of updates installed " & "and individual installation results:" 
' myLog.WriteLine
myLog.WriteLine now() & ": Installation Result: " & installationResult.ResultCode 
myLog.WriteLine now() & ": Reboot Required: " & installationResult.RebootRequired & vbCRLF 
myLog.WriteLine now() & ": Listing of updates installed " & "and individual installation results:" 

For I = 0 to updatesToInstall.Count - 1
    WScript.Echo I + 1 & "> " & updatesToInstall.Item(i).Title & ": " & installationResult.GetUpdateResult(i).ResultCode   
    myLog.WriteLine I + 1 & "> " & updatesToInstall.Item(i).Title & ": " & installationResult.GetUpdateResult(i).ResultCode   
Next

WScript.Echo    vbCRLF & now() & "==END OF WINDOWS UPDATE SCRIPT==" & vbCRLF
myLog.WriteLine vbCRLF & now() & "==END OF WINDOWS UPDATE SCRIPT==" & vbCRLF

myLog.Close

' Create a Shut Down Timer to reboot after the script is done.  
' This is based on timing, if the script runs at 7 then shutdown 1.5 hour (5400 Secs) after updates are complete
' objShell.Run "C:\WINDOWS\system32\shutdown.exe -r -t 5400"