@echo off
goto BEGINN
::===============================================================================
::-------------------------------------------------------------------------------
:: Monitormodell ermitteln und optim. Aufloesung einstellen - v. 2-0  - Mai 2018 
:: ------------------------------------------------------------------------------
::
:: Info: IT-Regionalbetreuer Vlbg. - Helmut Pajnik
::-------------------------------------------------------------------------------
:: Diese Batch ermittelt das Monitormodell mittels devcon.
:: Es wird dann die angegebene Wunsch-Aufloesung eingestellt.
:: Ebenso werden die passenden Hintergrundbilder aus 
:: c:\windows\hintergund\1024x768 (bzw. jeweilige Aufloesung)
:: nach c:\windows\hintergrund kopiert (und per Gruppenrichtlinie zugewiesen).
:: Derzeit unterstuetzte Hintergrundaufloesungen:
::    - 1024 x 768 
::    - 1280 x 1024 
::    - 1680 x 1050
::    - 1920 x 1080
::    - 1366 x 768 - Notebook
::    - 1600 x 900 - Notebook
:: ------------------------------------------------------------------------------
:: --Vorarbeit unter Windows fuer zusaetzliche Monitor-Modelle--
:: Im Geraetemanager die Modellnummer des angeschlosssenen Monitors suchen.
:: 
:: Dazu den Gertemanger oeffnen und das Monitormodell auswhlen 
:: - Eigenschaften der Monitore 
:: - unter Details die Gerteinstanzkennung bzw. Hardware-ID auswaehlen.
::   ergibt z.B: DISPLAY\MAX077B\4&3B42C36E&0&80861100&00&02
::         d.h:    DISPLAY
::                 MAX077B  = Modellnummer
::                 
::
:: --In dieser Batch--
:: In dieser Batch muss dann ein zusaetzlicher Block passend erstellt werden
:: Am besten einen vorhandennen kopieren und den Namen anpassen!
:: Es erfolgt dann die gezielte Abfrage auf das Modell!
:: zb: 
::    -----Maxdata-19-Zoll-alle-TFT--------------------------------
::    set DESCR=Belinea-Maxdata alle 19 Zoll
::    set MODELL=MAX07
::    set MYWIDTH=1280
::    set MYHEIGHT=1024
::    set MYFREQUENCY=60
::    ---weiter-wie-immer---
::
:: Bemerkung: Hier wurde nur MAX07 statt MAX077B genommen
::            wegen einiger nahezu baugleicher Typen 
::            
::
:: --Infodatei-----
:: Bei unbekanntem Monitor wird beim STart des PCs eine Infodatei 
:: mit den  ermittelten Werten des Monitors ins Verzeichnis
:: \\schule.aps\dfs\logs\monitor kopiert.
:: Diese Daten sollen bei der Eintragung helfen,
:: jedoch ohne Gewaehr. 
:: Ein Splitter kann bspw. falsche Werte liefern!
::===============================================================================





::===============================================================================
::
::==============================================================
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::-------------------------------------------------------------
::----------SUBROUTINE-CHECKSTRING-----------------------------
::-------------------------------------------------------------
:: aendert Varaible %MONITOR%
::-------------------------------------------------------------
:CheckString
"%STARTPATH%\%DEVCONPROG%" hwids * |find /I /C %1% >NUL
rem "%STARTPATH%\%DEVCONPROG%" hwids * |find /I  %1% 
if NOT ERRORLEVEL 1  set MONITOR=%MODELL%
rem nur wenn Monitor 1 x vorkommt
rem ping /n 2 127.0.0.1 > nul
goto :EOF
::--------------------------------------------------------------
::----------END-SUBROUTINE-CHECKSTRING--------------------------
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::===============================================================
::
::==============================================================================






:BEGINN
::
::==============================================================================
::------------------------------------------------------------------
::--- Initialisierung-----------------------------------------------
::------------------------------------------------------------------
::
set SERVERLOGDIR=\\schule.aps\dfs\logs
rem set SERVERLOGDIR=c:
rem fuer MonitorInfo-Datei bei unbekanntem Monitor
set MONITOR=UNKNOWN
set STARTPATH=%~dp0
if %STARTPATH:~-1%==\ set STARTPATH=%STARTPATH:~0,-1%
rem Pfad sichern und ev.vorhandenen Backslash wegschneiden
::
if /i %PROCESSOR_ARCHITECTURE%==x86   goto :x86
if /i %PROCESSOR_ARCHITECTURE%==amd64 goto :amd64
if /i %PROCESSOR_ARCHITECTURE%==IA64  goto :EOF
:: 
::----richtige-Version-zuordnen--------------------
::
::-------x86-----32bit-Betriebssystem (Intel und AMD)
:x86
set DEVCONPROG=devcon-i86.exe
set SETRESPROG=dccmd.exe
goto :END_INIT
::
::-------amd64---64bit-Betriebssystem (Intel und AMD)
:amd64
set DEVCONPROG=devcon-amd64.exe 
set SETRESPROG=dc64cmd.exe
goto :END_INIT
::
::------ia64  -- 64bit-Betriebssystem (Itanium Prozessor)
:ia64
rem --- haben wir nicht ---
goto :EOF
::
:END_INIT
::------------------------------------------------------------------
::--- Initialisierung-ENDE------------------------------------------
::==============================================================================



::==============================================================================
::--- Einstellungen nach COMPUTERNAME ------------------------------------------
::==============================================================================
::
::------------------------------------------------------------------------------
::------Sofort-RAUS-bei BEAMER oder Multimonitorbetrieb-------------------------
::------------------------------------------------------------------------------
:: Fuer folgende PCs dieses Programm sofort verlassen ...
::-----------------------------------------------------------------
::  (etwa Lehrer-PCs mit Beamer trotz 19 Zoll Monitor oder mit 2 Monitoren)
::  (wo die Aufloesung manuell am PC eingestellt werden soll              )
::
if /i %COMPUTERNAME%==PCDIR999        goto :ende
if /i %COMPUTERNAME%==PC99_mit_Beamer goto :ende
::
::-----Sofort-RAUS-ENDE---------------------------------------------------------
::
::
::------------------------------------------------------------------------------
::------Zwangsaufloesung bei BEAMER - Betrieb-----------------------------------
::------------------------------------------------------------------------------
:: Fuer folgende PCs unabhaengig vom Monitor angegebene Aufloesung einstellen
::----------------------------------------------------------------------------
::  (etwa Lehrer-PCs mit Beamer trotz 19 Zoll Monitor )
::
if /i %COMPUTERNAME%==PC_BEAM_1024    goto :SETRES_1024x768_60
if /i %COMPUTERNAME%==PC_HDTV         goto :SETRES_1920x1080_max
rem if /i %COMPUTERNAME%==PCHPTV          goto :SETRES_1920x1080_max
rem if /i %COMPUTERNAME%==PCHPTV          goto :SETRES_1280x1024_max
::
::------Zwangsaufloesung-ENDE---------------------------------------------------
::==============================================================================





::==============================================================================
::--- Einstellungen nach MONITORMODELL------------------------------------------
::==============================================================================
::
::=============================================================
echo ----------------------------------------------------------
echo Ermittle Monitormodell der Ausschreibungen 2002 bis 2011
echo ----------------------------------------------------------
::
::
::==================
:: CRT- 17 ZOLL
::==================
::
::-----2001-Siemens-CRT-17-Zoll--------------------------------
set DESCR=2001-Siemens-CRT-17-Zoll
set MODELL=SIE2001
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=75
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2001-EIZO-CRT-17-Zoll-----------------------------------
set DESCR=2001-EIZO-CRT-17-Zoll
set MODELL=EIZ1008
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=75
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2002-Samsung-CRT-17-Zoll--------------------------------
set DESCR=2002-Samsung-CRT-17-Zoll
set MODELL=SAM0027
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=75
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 15 Zoll TFT
::==================
::
::-----Maxdata-TFT-15-Zoll-generic-----------------------------
set DESCR=Maxdata-Belinea TFT- alle 15-Zoll 
set MODELL=MAX05
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%"   ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2003-Maxdata-TFT-15-Zoll--------------------------------
set DESCR=2003-Maxdata-TFT-15-Zoll
set MODELL=MAX0613
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----Samsung-TFT-15-Zoll--------------------------------
set DESCR=Samsung-Syncmaster-TFT-15-Zoll
set MODELL=SAM009A
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 17 Zoll TFT
::==================
::
::-----Maxdata-17-Zoll-alle-TFT--------------------------------
set DESCR=Belinea-17 Zoll
set MODELL=MAX06C2
set MYWIDTH=1280
set MYHEIGHT=1024
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----Belinea-17-Zoll-Rhrenmonitor---------------------------
set DESCR=Belinea-17 Zoll
set MODELL=MAX0B
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=75
echo Teste Kennung: "%MODELL%"   ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 19 Zoll TFT
::==================
::
::-----Maxdata-19-Zoll-alle-TFT--------------------------------
set DESCR=Belinea-Maxdata alle 19 Zoll
set MODELL=MAX07
set MYWIDTH=1280
set MYHEIGHT=1024
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%"   ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2009-ACER-19-Zoll---------------------------------------
set DESCR=2009-ACER-19-Zoll-LCD-B193 
set MODELL=ACR001D
set MYWIDTH=1280
set MYHEIGHT=1024
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2009b-ACER-19-Zoll--------------------------------------
set DESCR=2009b-ACER-19-Zoll-LCD-
set MODELL=ACR004B
set MYWIDTH=1280
set MYHEIGHT=1024
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 22 Zoll TFT
::==================
::
::-----2009-ACER-22-Zoll---------------------------------------
set DESCR=2009-ACER-22-Zoll
set MODELL=ACR0018
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2010-ACER-22-Zoll---------------------------------------
set DESCR=2010-ACER-22-Zoll
set MODELL=ACR0020
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2011-ACER-22-Zoll---------------------------------------
set DESCR=2011-ACER-22-Zoll
set MODELL=ACR0169
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2012-ACER-22-Zoll---------------------------------------
set DESCR=2012-ACER-22-Zoll
set MODELL=ACR0229
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::-----2013-LG-E2210PM-SN-22-Zoll------------------------------
set DESCR=2013-LG-22-Zoll
set MODELL=GSM57FB
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2013-LG-E2210PM-SN-22-Zoll------------------------------
set DESCR=2013-LG-22-Zoll
set MODELL=GSM57FA
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2014-ACER-B226WL-22-Zoll--------------------------------
set DESCR=2014-ACER-22-Zoll
set MODELL=ACR033A
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2015-ACER-B226WL-22-Zoll--------------------------------
set DESCR=2015-ACER-22-Zoll
set MODELL=ACR033A
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2016-ACER-B226WL-22-Zoll--------------------------------
set DESCR=2016-ACER-22-Zoll
set MODELL=ACR033A
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 23 Zoll TFT
::==================
::
::-----2013-EIZO-23-Zoll---------------------------------------
set DESCR=2013-EIZO-23-Zoll
set MODELL=ENC2394
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2013-EIZO-23-Zoll---------------------------------------
set DESCR=2013-EIZO-23-Zoll
set MODELL=ENC2395
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::==================
:: 24 Zoll TFT
::==================
::
::-----2010-ACER-24-Zoll---------------------------------------
set DESCR=2010-ACER-24-Zoll
set MODELL=ACR00D3
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::-----2013-LG-E2411PU-24-Zoll---------------------------------
set DESCR=2013-LG-24-Zoll
set MODELL=GSM583B
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2013-LG-E2411PU-24-Zoll---------------------------------
set DESCR=2013-LG-24-Zoll
set MODELL=GSM583A
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2014-ACER-B246HL-24-Zoll---------------------------------
set DESCR=2014-ACER-24-Zoll
set MODELL=ACR0331
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2015 und 2018-ACER-B246HL-24-Zoll---------------------------------
set DESCR=2015-ACER-24-Zoll
set MODELL=ACR0338
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2016-ACER-B246HL-24-Zoll---------------------------------
set DESCR=2016-ACER-24-Zoll
set MODELL=ACR0331
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::==================
:: 27 Zoll TFT
::==================
::
::-----2019-ACER-27-Zoll---------------------------------------
set DESCR=2019-ACER-27-Zoll
set MODELL=ACR0338
set MYWIDTH=2560
set MYHEIGHT=1440
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::==================
:: NOTEBOOKS
::==================
::
::
::-----2009-Lenovo-T-500-Hi_RES--------------------------------
set DESCR=2009-Notebook-Lenovo-T-500-Hi_RES 1680x1050
set MODELL=LEN4053
set MYWIDTH=1680
set MYHEIGHT=1050
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2010-Lenovo-T-510-Basic--------------------------------------
set DESCR=2010-Notebook-Lenovo-T-510-Basic 1366x768
set MODELL=LEN40B0
set MYWIDTH=1366
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2010-Lenovo-T-510-HI-RES--------------------------------------
::-----2013-Lenovo-T-530-HI-RES--------------------------------
set DESCR=2010-Notebook-Lenovo-T-510-Hi_RES 1600x900
set MODELL=LEN40B1
set MYWIDTH=1600
set MYHEIGHT=900
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2011-HP-ProBook-6550b-BASIC----------------------------
set DESCR=2011-Notebook-HP-ProBook-6550b-Basic 1366x768
set MODELL=SEC4351
set MYWIDTH=1366
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2011-HP-ProBook-6550b-HI-RES----------------------------
set DESCR=2011-Notebook-HP-ProBook-6550b-HI-RES 1600x900
set MODELL=AUO01EE
set MYWIDTH=1600
set MYHEIGHT=900
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::-----2012-HP-ProBook-6560b-BASIC----------------------------
set DESCR=2012-Notebook-HP-ProBook-6560b-Basic 1366x768
set MODELL=AUO23EC
set MYWIDTH=1366
set MYHEIGHT=768
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::
::-----2012b-HP-ProBook-6560b-BASIC2----------------------------
set DESCR=2012-Notebook-HP-ProBook-6560b-Basic 1366x768
set MODELL=LGD0258
set MYWIDTH=1600
set MYHEIGHT=900
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2012-HP-ProBook-6570b------------------------------
set DESCR=2012-Notebook-HP-ProBook-6570b 1600x900
set MODELL=AUO11EE
set MYWIDTH=1600
set MYHEIGHT=900
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2014-Lenovo-T540p------------------------------
set DESCR=2014-Notebook-Lenovo-T540p 1920x1080
set MODELL=LEN40B4
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2014-HP-ProBook-650G1------------------------------
set DESCR=2014-Notebook-HP-ProBook-650G1 1920x1080
set MODELL=AUO34ED
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2015-HP-ProBook-650G1------------------------------
set DESCR=2015-Notebook-HP-ProBook-650G1 1920x1080
set MODELL=CMN15C2
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2016-HP-ProBook-650G2------------------------------
set DESCR=2016-Notebook-HP-ProBook-650G2 1920x1080
set MODELL=CMN15C3
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2018-HP-ProBook-650G3------------------------------
set DESCR=2018-Notebook-HP-ProBook-650G3 1920x1080
set MODELL=AUO35ED
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=60
echo Teste Kennung: "%MODELL%" ---%DESCR% 
call :CheckString "MONITOR\%MODELL%"
if not %MONITOR%==UNKNOWN goto MONITOR_found
::-------------------------------------------------------------
::
::-----2018-HP-ProBook-650G4-----------------------
set DESCR=2018-Notebook-HP-ProBook-650G4 1920x1080 
set MODELL=CMN15D3 
set MYWIDTH=1920 
set MYHEIGHT=1080 
set MYFREQUENCY=60 
echo Teste Kennung: "%MODELL%" ---%DESCR%  
call :CheckString "MONITOR\%MODELL%" 
if not %MONITOR%==UNKNOWN goto MONITOR_found 
::-------------------------------------------------
::
::-----2019-HP-ProBook-650G4-----------------------
set DESCR=2019-Notebook-HP-ProBook-650G4 1920x1080 
set MODELL=LGD05D5 
set MYWIDTH=1920 
set MYHEIGHT=1080 
set MYFREQUENCY=60 
echo Teste Kennung: "%MODELL%" ---%DESCR%  
call :CheckString "MONITOR\%MODELL%" 
if not %MONITOR%==UNKNOWN goto MONITOR_found 
::-------------------------------------------------




::================================================================
::-------MONITOR NOT-FOUND------------------------
::================================================
rem Monitor-MODELL in obiger Liste nicht angegeben 
::
echo.
echo ---------------------------------------
echo Monitor nicht angegeben oder gefunden
echo ---------------------------------------
echo.
rem ==============================================
rem -- Ausgabefenster mit INFO -------------------
rem ==============================================
::
echo.> %temp%\Monitorinfo.txt
(
echo -------------------------------------------------
echo Info von IdentifyMonitor 
echo -------------------------------------------------
echo.
echo Problem: --^> Monitorname nicht in Batch gefunden
echo.
echo Diese Batch stellt die optimale Aufloesung ein 
echo und kopiert den passenden Bildschirmhintergrund.
echo Wegen fehlender Daten in der Batchdatei ist dies
echo fuer diesen Monitor derzeit nicht moeglich. 
echo.
echo ---Name des Computers------------------------
echo.%COMPUTERNAME%
echo.
echo ---Name^(n^) des Monitors in der Registry------
"%STARTPATH%\%DEVCONPROG%" hwids =MONITOR|find /i "monitor"|find /i /v "Name"
echo.
echo ---maximale Werte des Monitors---------------
"%STARTPATH%\%SETRESPROG%" -max -test |find /V "Test"
echo ^(Moeglicherweise sind die Werte nicht korrekt.
echo Bitte manuell einstellen und ueberpruefen!^)
echo ---------------------------------------------
echo.
echo Die Batchdatei ^(im NETLOGON^)
echo."%0"
echo anhand der obenstehenden Daten laut 
echo folgendem Muster sinnvoll ergaenzen:
echo.
echo ------------------------------------Beispiel----
echo.    -----Maxdata-19-Zoll-TFT--------------------
echo.    set DESCR=Belinea-Maxdata alle 19 Zoll
echo.    set MODELL=MAX07FF
echo.    set MYWIDTH=1280
echo.    set MYHEIGHT=1024
echo.    set MYFREQUENCY=60
echo.    - - - weiter wie immer  - - -
echo ------------------------------------------------
echo.
echo -- ODER --
echo wenn fuer diesen PC etwa wegen Beamer- oder
echo Dual-Monitorbetrieb keine automatische 
echo Aufloesungseinstellung gewuenscht ist, dann 
echo am Beginn der Batch bei -sofort raus- folgende 
echo Zeile einfgen:
echo.
echo if /i %%COMPUTERNAME%%==%COMPUTERNAME%   goto :ende
echo.
echo.
echo ---------------------------------------------
echo --- Zusatzinfo: Ausgaenge der Grafikkarte ---
echo ---------------------------------------------
echo.
"%STARTPATH%\%SETRESPROG%" -listmonitors
echo.
echo.
echo ----------------------------------------------------------------
echo ---weitere Infos auf VoBS oder bei den IT-Regionalbetreuern-----
echo --------------------------------------------- H. Pajnik --------
echo.
) >> %temp%\Monitorinfo.txt
start "INFO" "notepad.exe" %temp%\Monitorinfo.txt
if not exist "%SERVERLOGDIR%\." (
echo Logverzeichnis %SERVERLOGDIR% nicht gefunden
) else (
echo Kopiere Info ins Logverzeichnis %SERVERLOGDIR% ...
if not exist "%SERVERLOGDIR%\monitor\." md "%SERVERLOGDIR%\monitor"
copy "%temp%\Monitorinfo.txt" "%SERVERLOGDIR%\Monitor\Monitorinfo-%COMPUTERNAME%.txt" /Y
)
REM 
REM ---Kurze-Verschnaufpause--------------------
ping -n 8 127.0.0.1 >nul
rem ==============================================
rem -- Ausgabefenster mit INFO --ENDE-------------
rem ==============================================
::-------NOT-FOUND-END----------------------------
::================================================================
::
goto :ende






:: ========MANUELLE EINSTELLUNG=================================================
:: 
::------------------Manuelle Einstellung -1024 x 768 - 60Hz --------
:SETRES_1024x768_60
set MYWIDTH=1024
set MYHEIGHT=768
set MYFREQUENCY=60
set MONITOR=Admin-Vorgabe-%MYWIDTH%x%MYHEIGHT%
goto MONITOR_found
::------------------------------------------------------------------
:: 
::------------------Manuelle Einstellung -1280 x 1024 max Hz--------
:SETRES_1280x1024_max
set MYWIDTH=1280
set MYHEIGHT=1024
set MYFREQUENCY=max
set MONITOR=Admin-Vorgabe-%MYWIDTH%x%MYHEIGHT%
goto MONITOR_found
::------------------------------------------------------------------
:: 
::------------------Manuelle Einstellung -1920 x 1080 max Hz--------
:SETRES_1920x1080_max
set MYWIDTH=1920
set MYHEIGHT=1080
set MYFREQUENCY=max
set MONITOR=Admin-Vorgabe-%MYWIDTH%x%MYHEIGHT%
goto MONITOR_found
::-----------------------------------------------------------
::
:: ========MANUELLE EINSTELLUNG-ENDE============================================













::---------FOUND-------------------------------------------------------------------------------------------------
:MONITOR_found
echo.
echo ----------------------------------------------
echo Das Monitormodell ist: %MONITOR%
echo ----------------------------------------------
echo.
echo Aufloesung von %MYWIDTH% x %MYHEIGHT% mit %MYFREQUENCY% Herz Wiederholfrequenz
echo.
REM ---Kurze-Verschnaufpause--------------------
ping -n 5 127.0.0.1 > nul
::
::
REM ---Aufloesung-einstellen---------------------------------------------------------------
"%STARTPATH%\%SETRESPROG%" /width=%mywidth% /height=%myheight% /refresh=%myfrequency% /depth=max 
rem "%STARTPATH%\DCCmd.exe" /width=%mywidth% /height=%myheight% /refresh=max /depth=max 
rem refresh=max ermittelt Refresh selbst  - Funktion jedoch von uns nicht ausreichend getestet
rem daher derzeit manuelle Angabe verwenden
::
::
REM ---Hintergrundbild-loeschen-und-kopieren-----------------------------------------------
del c:\windows\hintergrund\*.bmp /f/Q
del c:\windows\hintergrund\*.jpg /f/Q
xcopy "c:\windows\hintergrund\%MYWIDTH%x%MYHEIGHT%\*.*"  "c:\windows\hintergrund\*.*" /k/r/e/i/s/c/h/y
::
::-------FOUND-END--------------------------------------------------------------------------------------------------
::
:ende 
:EOF
