echo 'Passe Rechte fuer EDGE an ... '

function MakeACE($sid, $right) {
    $id = New-Object System.Security.Principal.SecurityIdentifier($sid)
    New-Object System.Security.AccessControl.RegistryAccessRule($id, 
                                                                $right,
                                                                [System.Security.AccessControl.InheritanceFlags]::ContainerInherit,
                                                                [System.Security.AccessControl.PropagationFlags]::None,
                                                                [System.Security.AccessControl.AccessControlType]::Allow)
} 

if ([Environment]::OSVersion.Version.Major -eq 10) {
	
	get-childitem -Path "Registry::HKEY_CURRENT_USER\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppContainer\Mappings\" | Foreach {
		$prop = Get-ItemProperty -Path Registry::$_
		$sid = $prop.PSChildName
		$app = $prop.Moniker
	
		$key = "HKCU:\Software\Classes\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppContainer\Storage\$($app)"
		$acl = Get-Acl $key
	
		$ace = MakeACE $sid ([System.Security.AccessControl.RegistryRights]::FullControl)
	
	        $acl.AddAccessRule($ace)
	
	
		if (!$app.CompareTo("microsoft.microsoftedge_8wekyb3d8bbwe")) {
			$ace = MakeACE "S-1-15-3-3624051433-2125758914-1423191267-1740899205-1073925389-3782572162-737981194" ([System.Security.AccessControl.RegistryRights]::SetValue)
			$acl.AddAccessRule($ace)
	
			$ace = MakeACE "S-1-15-3-3624051433-2125758914-1423191267-1740899205-1073925389-3782572162-737981194" ([System.Security.AccessControl.RegistryRights]::CreateSubKey)
			$acl.AddAccessRule($ace)
	
	        }
	
	
        Set-Acl $key $acl
	
	
	}


}
echo Rechte sind nun angepasst 
timeout /t 10